
DECLARE FUNCTION MatchOpCode(BYVAL Code AS WORD) AS INTEGER
DECLARE FUNCTION MatchOpText(BYVAL Text AS STRING) AS INTEGER
DECLARE FUNCTION GetOpCode(BYVAL Code AS WORD) AS INTEGER
DECLARE FUNCTION GetOpText(BYVAL Code AS WORD) AS STRING
DECLARE FUNCTION GetOperType(BYVAL Code AS WORD) AS INTEGER
DECLARE FUNCTION GetOperText(BYVAL Code AS WORD) AS STRING

'
' Opcodes  0..7  are NO.REF
'
' referenced by RefText[]
'

%NO.REF   = 0
%CODE.REF = 1
%DATA.REF = 2

%FIRST.REF = 8
%NBR.OPCODES = 49

%OPC.HALT     = 0
%OPC.STATUS   = 1
%OPC.RETURN   = 2
%OPC.NOP      = 3
%OPC.DEBUG    = 4
%OPC.XXX.5    = 5
%OPC.XXX.6    = 6
%OPC.XXX.7    = 7
%OPC.CALL     = 8
%OPC.LOOP     = 9
%OPC.IFTRUE   = 10
%OPC.IFFALSE  = 11
%OPC.GOTO     = 12
%OPC.BAUD     = 13
%OPC.DATABITS = 14
%OPC.STOPBITS = 15
%OPC.PARITY   = 16
%OPC.QUIET    = 17
%OPC.HANGUP   = 18
%OPC.REPLY    = 19
%OPC.DELAY    = 20
%OPC.SETCOUNT = 21
%OPC.SETWAIT  = 22
%OPC.SAY      = 23
%OPC.WAITFOR  = 24
%OPC.SETPACE  = 25
%OPC.SETCASE  = 26
%OPC.ACCEPT   = 27
%OPC.PROTOCOL = 28
%OPC.SEND     = 29
%OPC.RECEIVE  = 30
%OPC.TEST     = 31
%OPC.IF       = 32
%OPC.IFNOT    = 33

%OPC.XXX.34   = 34
%OPC.XXX.35   = 35
%OPC.XXX.36   = 36
%OPC.XXX.37   = 37
%OPC.XXX.38   = 38
%OPC.XXX.39   = 39
%OPC.XXX.40   = 40

%OPC.USER1    = 41
%OPC.USER2    = 42
%OPC.USER3    = 43
%OPC.USER4    = 44
%OPC.USER5    = 45
%OPC.USER6    = 46
%OPC.USER7    = 47
%OPC.USER8    = 48

%REF.HALT     = %NO.REF
%REF.STATUS   = %NO.REF
%REF.RETURN   = %NO.REF
%REF.NOP      = %NO.REF
%REF.DEBUG    = %NO.REF
%REF.CALL     = %CODE.REF
%REF.LOOP     = %CODE.REF
%REF.IFTRUE   = %CODE.REF
%REF.IFFALSE  = %CODE.REF
%REF.GOTO     = %CODE.REF
%REF.DELAY    = %DATA.REF
%REF.BAUD     = %DATA.REF
%REF.DATABITS = %DATA.REF
%REF.STOPBITS = %DATA.REF
%REF.PARITY   = %DATA.REF
%REF.QUIET    = %DATA.REF
%REF.HANGUP   = %DATA.REF
%REF.REPLY    = %DATA.REF
%REF.SETCOUNT = %DATA.REF
%REF.SETWAIT  = %DATA.REF
%REF.SAY      = %DATA.REF
%REF.WAITFOR  = %DATA.REF
%REF.SETPACE  = %DATA.REF
%REF.SETCASE  = %DATA.REF
%REF.IF       = %DATA.REF
%REF.PROTOCOL = %DATA.REF
%REF.SEND     = %DATA.REF
%REF.RECEIVE  = %DATA.REF
%REF.TEST     = %DATA.REF
%REF.IFNOT    = %DATA.REF

%REF.ACCEPT   = %DATA.REF
%REF.USER     = %DATA.REF

